--- /dev/null	2013-10-07 21:44:00.000000000 +0000
+++ new/cpp/squash.py	2013-10-07 21:44:00.034739752 +0000
@@ -0,0 +1,30 @@
+import sys
+results = {}
+buf = ''
+fname = ''
+for line in sys.stdin:
+    if line.startswith('---'):
+        if buf:
+            if buf in results:
+                results[buf].extend([fname])
+            else:
+                results[buf] = [fname]
+        buf = ''
+        fname = line.split(' ')[1]
+    elif line.startswith('+++'):
+        pass
+    elif line.startswith('@@'):
+        if buf:
+            if buf in results:
+                results[buf].extend([fname])
+            else:
+                results[buf] = [fname]
+        buf = ''
+    else:
+        buf += line
+
+for key in results.iterkeys():
+    print "From %s" % ', '.join(results[key])
+    print "="*68
+    print '   %s' % '\n   '.join(key.splitlines())
+    print
